<!DOCTYPE html>
<html lang="en">

    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>File UpLoad</title>
        <script src="https://www.google.com/recaptcha/api.js" async defer></script>
    </head>

    <body>
        <form name = "formfile">
            <span name = "percent">0</span> %
            <input name="fileupload" type="file"> <br> <br>
            <div
                class="g-recaptcha"
                data-sitekey="6Lfz_eAUAAAAALRzE-JrvcUS_l9IG_vlux1seUWh"
                data-callback='onSubmit'
                data-size="invisible"
            ></div>
            <input type="submit">
            <div name = "info"></div>
        </form>
    </body>


    <script>
        const fileupload = document.querySelector("input[name='fileupload']");
        const percent = document.querySelector("span[name='percent']");
        const info = document.querySelector("div[name='info']")
        const form = document.querySelector("form[name='formfile']");
        let file;

        const xmlHttpRequest = new XMLHttpRequest();

        xmlHttpRequest.upload.onprogress = function(e) {
            percent.textContent = Math.round((e.loaded * 100) / file.size);
        }

        xmlHttpRequest.onreadystatechange = function () {

            if (this.readyState == 4) {
                info.innerHTML = `
                    <br> Upload success! <br>
                    FileName: ${JSON.parse(this.responseText).fileName} <br>
                    FileSize: ${JSON.parse(this.responseText).fileSize} <br>
                `;
            }

        }

        fileupload.addEventListener('change', function (e) {
            file = e.target.files[0];
        });

        form.addEventListener('submit', function(e) {
            e.preventDefault();

            /**
             * Validate before solving the ReCapthca
            */
            // if (!file) {
            //     info.innerHTML = "<br>File is required!";
            //     return;
            // }

            grecaptcha.execute();

        });

        function onSubmit(token) {

            /**
             * Validate after solving the ReCapthca
            */
            if (!file) {
                info.innerHTML = "<br>File is required!";
                return;
            }

            const formData = new FormData();
            formData.append('file', file);

            xmlHttpRequest.open('POST', 'http://localhost:8080/file');
            xmlHttpRequest.send(formData);

        }
    </script>

</html>